C+    create_setup_parameters.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE PARAMETER RANGES SET IN parameter_range.input
C+    AND GENERATES A LIST OF THE REQUIRED PAIRS OF CONTROL PARAMETER/WAVE 
C+    SPEED VALUES. THE PROGRAM CALCULATES AN APPROPRIATE NUMBER OF 
C+    SIGNIFICANT FIGURES TO USE, AND TRUNCATES ALL OF THE OUTPUT VALUES
C+    ACCORDING TO THIS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(13,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX,NPP
      READ(13,*)CMIN,CMAX,NC
      CLOSE(13)
C-----
C     Calculate an appropriate number of signnificant figures for 
C       the control parameter
      DPP=((PPMAX-PPMIN)/NPP)
      IPOWPP=2-ILEAD(DPP)
      FACTPP=10**(IPOWPP)
      DC=((CMAX-CMIN)/NC)
      IPOWC=2-ILEAD(DC)
      FACTC=10**(IPOWC)
C-----
      OPEN(12,FILE='../temp_files/parameter_list.data'
     &,STATUS='NEW')
      DO 100 I=1,NC
         C=CMIN+(I-1)*(CMAX-CMIN)/(NC-1)
         C=(INT(C*FACTC))/FACTC
         DO 200 J=1,NPP
            PP=PPMIN+(J-1)*(PPMAX-PPMIN)/(NPP-1)
            PP=(INT(PP*FACTPP))/FACTPP
            WRITE(12,9000)PP,C
 200     CONTINUE
 100  CONTINUE
      CLOSE(12)
C-----
      STOP
 9000 FORMAT(2E18.10E2) 
      END
      INTEGER FUNCTION ILEAD(X)
C     This function returns the location of the first non-zero
C       decimal digit. If this is in front of the decimal point
C       it is a positive number, with 0 indicating the unit 
C       position, 1 indicating the tens position etc. If it is
C       behind the decimal point, it is a negative number, with 
C       -1 indicating the first position behind the decimal point
C       etc.
      IMPLICIT REAL*8 (A-H,K,O-Z)
      Y=LOG10(DABS(X)+1.0D-12)
C     The addition of 1.0D-12 makes sure that the correct value is
C       given at thresholds, e.g. that ILEAD(0.01)=-2 not -1 
      ILEAD=INT(Y)
      IF (DABS(X).LT.1.0D0) THEN
         ILEAD=ILEAD-1
      ENDIF
      RETURN
      END
