C+    evaluecalc.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CALCULATES THE EIGENVALUES AND
C+    EIGENVECTORS (I.E. DISCRETISED EIGENFUNCTIONS) FOR CASES
C+    WHERE THESE ARE PERIODIC OVER THE PERIOD OF THE PERIODIC
C+    TRAVELLING WAVE. ALL THE EIGENVALUES ARE CALCULATED, BUT
C+    ONLY THOSE WITH SUFFICIENTLY LARGE REAL PART
C+    ARE WRITTEN TO THE OUTPUT FILES. THE INPUT CONSTANT
C+    NEVALUES SPECIFIES THE NUMBER OF EIGENVALUES (AND
C+    EIGENFUNCTIONS) WRITTEN TO THE OUTPUT FILES, AND
C+    THEN USED AS STARTING POINTS FOR CONTINUING THE
C+    SPECTRUM; THE INPUT CONSTANT IPOSRE DETERMINES WHETHER
C+    JUST EIGENVALUES WITH POSITIVE/ZERO IMAGINARY PART 
C+    (IPOSRE=1), OR ALL EIGENVALUES (IPOSRE=0), ARE USED FOR 
C+    OUTPUT. SINCE THE SPECTRUM IS EXPECTED TO HAVE 
C+    REFLECTIONAL SYMMETRY ABOUT THE REAL AXIS, THE CHOICE 
C+    IPOSRE=1 IS MORE COMPUTATIONALLY EFFICIENT.
C+    NOTE THAT THIS PROGRAM IS EDITTED BY A SCRIPT FILE 
C+    GENERATED BY evaluecalc_prepare.f BEFORE BEING COMPILED
C+    AND RUN.
C++   
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER(NPTS=400)
      PARAMETER(NPDE=2)
      PARAMETER(NPTW=3)
C     Note: npts, npde and nptw are replaced by the appropriate values
C           in evaluecalc.script, prior to compiling and running
      PARAMETER(NNN=NPDE*NPTS)
      PARAMETER(LWORKP=6*NNN)
C     Note: LWORKP can be reduced to 3*NNN, but the larger value gives
C           slightly reduced run times
      PARAMETER(LWRKGP=15*NNN)
C     Note: LWRKGP can be reduced to 10*NNN, but the larger value gives
C           slightly reduced run times
      DIMENSION A(NNN,NNN),WR(NNN),WI(NNN),B(NNN,NNN),
     &     VR(NNN,NNN),VL(NNN,NNN),WORK(LWORKP),WORKG(LWRKGP)
      DIMENSION ALPHAR(NNN),ALPHAI(NNN),BETA(NNN)
      DIMENSION SCALE(NNN),RCONDE(NNN),RCONDV(NNN)
      DIMENSION IWORK(2*NNN-2),RSCALE(NNN),IWORKG(NNN+6)
      DIMENSION Z(NPTS),UPTW(NPTW,NPTS)
      DIMENSION UHPTWR(NPTW,NPTS),UHPTWI(NPTW,NPTS)
      DIMENSION UHPDER(NPDE,NPTS),UHPDEI(NPDE,NPTS)
      DIMENSION UHTWLR(NPTW),UHTWLI(NPTW)
      DIMENSION EFNR(NNN),EFNI(NNN)
      DIMENSION PTWWRK(NPTW),PDEWRK(NPDE)
      CHARACTER*1 JOBVR,JOBVL,AG,BALANC,SENSE
      CHARACTER*3 AWHICH
      LOGICAL LLEFT(NNN),FIRST,BWORK(NNN)
      CALL GINFO(INFO)
C-----
      OPEN(11,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(11)
      DO 422 I=1,9
         READ(11,*)
 422  CONTINUE
      READ(11,*)NEVALS,IPOSRE
      CLOSE(11)
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      DO 423 I=1,7
         READ(11,*)
 423  CONTINUE
      READ(11,*)DUMMY,EVIBND
      CLOSE(11)
C-----
      OPEN(11,FILE='../ptwcalc/data_files/ptw.params'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PP,C,PERIOD,NLINES
      CLOSE(11)
      IF (NLINES.NE.NPTS+1) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(
     &        ''ERROR: PROBLEM WITH VALUE OF NPTS IN evaluecalc.f'')')
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
      OPEN(12,FILE='../ptwcalc/data_files/ptw.soln'
     &,STATUS='OLD')
      REWIND(12)
      DO 100 I=1,NPTS
         READ(12,*,END=101)Z(I),(UPTW(J,I),J=1,NPTW)
         Z(I)=Z(I)*PERIOD
 100  CONTINUE
      CLOSE(12)
      IF (NPTS.LT.4) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: npts TOO SMALL IN evaluecalc.f'')')
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
C-----
      CALL DISCEF(NPDE,NPTW,NPTS,PP,C,Z,UPTW,PERIOD,A,PTWWRK)
      CALL GETAG(AG)
C-----
      JOBVL='V'
      JOBVR='V'
      N=NNN
      LDA=N
      LDB=N
      LDVL=N
      LDVR=N
      LWORK=LWORKP
      LWORKG=LWRKGP
      BALANC='B'
      SENSE='E'
      EPSMCH=DLAMCH('E')
      IF (AG.EQ.'n') THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(
     &''The eigenvalue problem is of standard type'')')
         WRITE(66,'(
     &''Solving for eigenvalues and eigenvectors using'',
     &'' LAPACK routine DGEEVX'')')
         CLOSE(66)
         CALL IOUT(INFO,'minor')
         CALL DGEEVX(BALANC,JOBVL,JOBVR,SENSE,N,A,LDA,WR,WI,
     &        VL,LDVL,VR,LDVR,ILO,IHI,SCALE,ABNRM,
     &        RCONDE,RCONDV,WORK,LWORK,IWORK,INFODG)
         ABNORM=ABNRM
         DO 500 I=1,N
            LLEFT(I)=.TRUE.
 500     CONTINUE
      ELSE
         CALL DISCEG(NPDE,NPTS,B)
         IB1=0
         DO 118 I=1,N
            IF (B(I,I).GT.0.1D0) THEN
               IB1=IB1+1
            ENDIF
 118     CONTINUE
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(
     &''The eigenvalue problem is of generalised type'')')
         WRITE(66,'(
     &''Solving for eigenvalues and eigenvectors using'',
     &'' LAPACK routine DGGEVX'')')
         CLOSE(66)
         CALL IOUT(INFO,'minor')
         CALL DGGEVX(BALANC,JOBVL,JOBVR,SENSE,N,A,LDA,B,LDB,
     &        ALPHAR,ALPHAI,BETA,VL,LDVL,VR,LDVR,ILO,
     &        IHI,SCALE,RSCALE,ABNRM,BBNRM,RCONDE,
     &        RCONDV,WORKG,LWORKG,IWORKG,BWORK,INFODG)
C        NOTE: This is an inefficient way of finding the eigenvalues.
C              The eigenvalue problem has the form
C                   ( P   Q ) (x)          ( I  0 ) (x)
C                   (       ) ( ) = lambda (      ) ( )
C                   ( R   S ) (y)          ( 0  0 ) (y)
C              where P and S are square matrices, Q and R are
C              rectangular matrices, and I is the identity matrix.
C              Assuming that S is invertible, this can be rewritten as 
C                   ( P - Q * S^-1 * R ) x = lambda x
C                   y = - S^-1 R x
C              which is a standard eigenvalue problem. Moreover S is 
C              dominated by its diagonal entries and thus is expected 
C              to be invertible. I have not implemented this approach 
C              simply to avoid the greater complexity of coding; the 
C              approach that I have used only involves a very minor 
C              addition to the code for the standard case. To implement 
C              the more efficient approach it would be necessary to have 
C              an array whose dimension involves the number of equations 
C              with time derivatives, which would mean some rewriting of 
C              prepare_evaluecalc.f as well as this program. The results 
C              would be the same, except possibly for numerical error 
C              differences, but run times would be reduced.
         ABNORM=DLAPY2(ABNRM,BBNRM)
         IBNZ=0
         DO 120 I=1,N
            IF (BETA(I).EQ.0.0D0) THEN
               LLEFT(I)=.FALSE.
            ELSE
               IBNZ=IBNZ+1
               LLEFT(I)=.TRUE.
               WR(I)=ALPHAR(I)/BETA(I)
               WI(I)=ALPHAI(I)/BETA(I)
            ENDIF
 120     CONTINUE
         IF (IBNZ.LT.NEVALS) THEN
            OPEN(66,FILE='../temp_files/message.txt'
     &           ,STATUS='OLD')
            REWIND(66)
            WRITE(66,'(
     &      ''ERROR: IN evaluecalc.f'')')
            WRITE(66,'(
     &      8X,''THE NUMBER OF FINITE EIGENVALUES'')')
            WRITE(66,'(
     &      8X,''IS'',I8,'' WHICH IS LESS THAN'')')IBNZ
            WRITE(66,'(
     &      8X,''THE REQUESTED NUMBER, WHICH IS'',I8)')
     &      NEVALS
            WRITE(66,'(
     &      8X,''A POSSIBLE REMEDY IS TO REDUCE THE'')')
            WRITE(66,'(8X,''INPUT PARAMETER nevals'')')
            CLOSE(66)
            CALL IOUT(INFO,'error')
         ELSE
            OPEN(66,FILE='../temp_files/message.txt'
     &           ,STATUS='OLD')
            REWIND(66)
            WRITE(66,'(
     &      ''THE NUMBER OF EIGENVALUES IS'',I8)')IBNZ
            WRITE(66,'(
     &      ''  AND THE EXPECTED NUMBER IS'',I8)')IB1
            CLOSE(66)
            CALL IOUT(INFO,'minor')
            IF (IBNZ.NE.IB1) THEN
               OPEN(66,FILE='../temp_files/message.txt'
     &              ,STATUS='OLD')
               REWIND(66)
               WRITE(66,'(
     &         ''WARNING: THE ACTUAL AND EXPECTED NUMBER'')')
               WRITE(66,'(
     &         ''         OF EIGENVALUES DO NOT MATCH'')')
               CLOSE(66)
               CALL IOUT(INFO,'error')
            ENDIF
         ENDIF
      ENDIF
      IF (INFODG.NE.0) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
         REWIND(66)
         IF (AG.EQ.'n') THEN
            WRITE(66,'(
     &           ''ERROR: in DGEEVX, called by evaluecalc.f'')')
            WRITE(66,'(8X,''the DGEEVX INFO parameter ='',I3)')
     &           INFODG
         ELSE
            WRITE(66,'(
     &           ''ERROR: in DGGEVX, called by evaluecalc.f'')')
            WRITE(66,'(8X,''the DGGEVX INFO parameter ='',I3)')
     &           INFODG
         ENDIF
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
C-----
      IWHICH=99
      DO 200 J=0,NEVALS
C        Note that J=0 is a special value in which the output
C        corresponds to the eigenvalue closest to the origin.
         IWHICH=IWHICH+1
         OPEN(21,FILE='../temp_files/evaluecalc.temp'
     &,STATUS='OLD')
         REWIND(21)
         WRITE(21,'(I3)')IWHICH
         CLOSE(21)
         OPEN(21,FILE='../temp_files/evaluecalc.temp'
     &,STATUS='OLD')
         REWIND(21)
         READ(21,'(A3)')AWHICH
         CLOSE(21)
C------
         IF (J.EQ.0) THEN
            FIRST=.TRUE.
            DO 502 I=N,1,-1
C              Note that the order is backwards in I so that
C              IMAX and IMAX+1 are complex conjugate pairs
C              in the case of complex eigenvalues.
               SIZE=ABS(SQRT(WR(I)*WR(I)+WI(I)*WI(I)))
               IF (FIRST) THEN
                  SIZMIN=SIZE
                  FIRST=.FALSE.
               ELSE
                  SIZMIN=MIN(SIZMIN,SIZE)
               ENDIF
               IF (SIZE.EQ.SIZMIN) THEN
                  IMAX=I
               ENDIF
 502        CONTINUE
         ELSE
 199        FIRST=.TRUE.
            DO 501 I=N,1,-1
C              Note that the order is backwards in I so that
C              IMAX and IMAX+1 are complex conjugate pairs
C              in the case of complex eigenvalues.
               IF (LLEFT(I)) THEN
                  IF (FIRST) THEN
                     WRMAX=WR(I)
                     FIRST=.FALSE.
                  ELSE
                     WRMAX=MAX(WRMAX,WR(I))
                  ENDIF
                  IF (WR(I).EQ.WRMAX) THEN
                     IMAX=I
                  ENDIF
               ENDIF
 501        CONTINUE
            LLEFT(IMAX)=.FALSE.
            IF ((IPOSRE.EQ.1).AND.(WI(IMAX).LT.0.0D0)) THEN
               GOTO 199
            ENDIF
            IF ((EVIBND.GE.0.0D0).AND.
     &           (ABS(WI(IMAX)).GT.EVIBND)) THEN
               GOTO 199
            ENDIF
         ENDIF
C--------------
         EVALR=WR(IMAX)
         EVALI=WI(IMAX)
         EERRBD=EPSMCH*ABNORM/RCONDE(IMAX)
         IF (AG.NE.'n') THEN
            EERRBD=EERRBD*(1.0D0+EVALR*EVALR+EVALI*EVALI)
C           In the generalised case, the error bound EERRBD
C           from LAPACK is the "chordal distance" between the
C           calculated and actual eigenvalues. (See the LAPACK
C           documentation for details). The above line converts
C           this chordal distance into a very crude estimate of 
C           the error bound on the actual eigenvalue, meaning 
C           that, very approximately, it bounds the absolute
C           value of (actual eigenvalue) - (calculated eigenvalue).
         ENDIF
         IF (EVALI.EQ.0.0D0) THEN
            DO 210 JJ=1,NNN
               EFNR(JJ)=VR(JJ,IMAX)
               EFNI(JJ)=0.0D0
 210        CONTINUE
         ENDIF
         IF (EVALI.GT.0.0D0) THEN
            IF (IMAX.EQ.NNN) THEN
               OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
               WRITE(66,'(
     &''ERROR: EVALI>0 AND IMAX=NNN IN evaluecalc.f'')')
               CLOSE(66)
               CALL IOUT(INFO,'error')
               CALL ISTOP(INFO)
            ENDIF
            DO 220 JJ=1,NNN
               EFNR(JJ)=VR(JJ,IMAX)
               EFNI(JJ)=VR(JJ,IMAX+1)
 220        CONTINUE
         ENDIF
         IF (EVALI.LT.0.0D0) THEN
            IF (IMAX.EQ.1) THEN
               OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
               WRITE(66,'(
     &''ERROR: EVALI<0 AND IMAX=1 IN evaluecalc.f'')')
               CLOSE(66)
               CALL IOUT(INFO,'error')
               CALL ISTOP(INFO)
            ENDIF
            DO 230 JJ=1,NNN
               EFNR(JJ)=VR(JJ,IMAX-1)
               EFNI(JJ)=-VR(JJ,IMAX)
 230        CONTINUE
         ENDIF         
C--------------
C     Now extract eigenfunctions and normalise
C--------------
         DO 239 IPDE=1,NPDE
         DO 240 JPTS=1,NPTS
            UHPDER(IPDE,JPTS)=EFNR(JPTS+NPTS*(IPDE-1))
            UHPDEI(IPDE,JPTS)=EFNI(JPTS+NPTS*(IPDE-1))
 240     CONTINUE
 239  CONTINUE
      DO 241 JPTS=1,NPTS
         IPOINT=JPTS
         CALL PDE2TW(NPDE,NPTW,NPTS,Z,UHPDER,IPOINT,UHTWLR,
     &PDEWRK)
         CALL PDE2TW(NPDE,NPTW,NPTS,Z,UHPDEI,IPOINT,UHTWLI,
     &PDEWRK)
         DO 244 IPTW=1,NPTW
            UHPTWR(IPTW,JPTS)=UHTWLR(IPTW)
            UHPTWI(IPTW,JPTS)=UHTWLI(IPTW)
 244     CONTINUE
 241  CONTINUE
      RNORM=0.0D0
      DO 250 JPTS=1,NPTS
         IF (JPTS.EQ.1) THEN
            DZ=(Z(2)-Z(NPTS)+PERIOD)/(2*PERIOD)
         ENDIF
         IF (JPTS.EQ.NPTS) THEN
            DZ=(Z(1)+PERIOD-Z(NPTS-1))/(2*PERIOD)
         ENDIF
         IF ((JPTS.GT.1).AND.(JPTS.LT.NPTS)) THEN
            DZ=(Z(JPTS+1)-Z(JPTS-1))/(2*PERIOD)
         ENDIF
         DO 251 IPTW=1,NPTW
            RNORM=RNORM+DZ*(
     &           UHPTWR(IPTW,JPTS)**2+
     &           UHPTWI(IPTW,JPTS)**2)
 251     CONTINUE
 250  CONTINUE
      DO 260 JPTS=1,NPTS
         DO 261 IPTW=1,NPTW
            UHPTWR(IPTW,JPTS)=UHPTWR(IPTW,JPTS)/SQRT(RNORM)
            UHPTWI(IPTW,JPTS)=UHPTWI(IPTW,JPTS)/SQRT(RNORM)
 261     CONTINUE
 260  CONTINUE
C--------------
C     Now write output files
C--------------
      IF (J.EQ.0) THEN
         OPEN(16,FILE=
     &'../spectrum/data_files/efn_at_zero.dat'
     &,STATUS='NEW')
      ELSE
         OPEN(16,FILE=
     &'../spectrum/data_files/spectrum.dat'
     &//AWHICH
     &,STATUS='NEW')
      ENDIF
         DO 268 JPTS=1,NPTS
            DO 269 IPTW=1,NPTW
               IF (ABS(UPTW(IPTW,JPTS)).LT.1.0D-99) THEN
                  UPTW(IPTW,JPTS)=0.0D0
               ENDIF
               IF (ABS(UHPTWR(IPTW,JPTS)).LT.1.0D-99) THEN
                  UHPTWR(IPTW,JPTS)=0.0D0
               ENDIF
               IF (ABS(UHPTWI(IPTW,JPTS)).LT.1.0D-99) THEN
                  UHPTWI(IPTW,JPTS)=0.0D0
               ENDIF
 269        CONTINUE
 268     CONTINUE
C        Note: The above lines avoid problems caused by values with 
C              (negative) three-digit exponents.
         DO 270 JPTS=1,NPTS
            WRITE(16,9000)Z(JPTS)/PERIOD,
     &           (UPTW(IPTW,JPTS),IPTW=1,NPTW),
     &           (UHPTWR(IPTW,JPTS),UHPTWI(IPTW,JPTS),
     &           IPTW=1,NPTW)
 270     CONTINUE
         ONE=1.0D0
         WRITE(16,9000)ONE,
     &        (UPTW(IPTW,1),IPTW=1,NPTW),
     &        (UHPTWR(IPTW,1),UHPTWI(IPTW,1),
     &        IPTW=1,NPTW)
         CLOSE(16)
         IF (J.EQ.0) THEN
            OPEN(17,FILE=
     &'../spectrum/data_files/evalue_at_zero.dat'
     &,STATUS='NEW')
         ELSE
            OPEN(17,FILE=
     &'../spectrum/data_files/spectrum.evalue'
     &//AWHICH
     &,STATUS='NEW')
         ENDIF
         IF (ABS(EVALR).LT.1.0D-99) THEN
            EVALR=0.0D0
         ENDIF
         IF (ABS(EVALI).LT.1.0D-99) THEN
            EVALI=0.0D0
         ENDIF
         IF (ABS(EERRBD).LT.1.0D-99) THEN
            EERRBD=0.0D0
         ENDIF
         WRITE(17,9001)EVALR,EVALI,EERRBD
         CLOSE(17)
C--------------
 200  CONTINUE
      OPEN(18,FILE='data_files/errorbound.msg'
     &,STATUS='NEW')
      IF (AG.EQ.'n') THEN
         WRITE(18,9100)
      ELSE
         WRITE(18,9101)
      ENDIF
      CLOSE(18)
C     Note: the file errorbound.msg is only used if
C           evaluecalc.f is being run via the command
C           eigenvalue_convergence
C-----
      CALL ISTOP(INFO)
 101  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(
     &     ''ERROR: PREMATURE END OF LOOP 100 in evaluecalc.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CALL ISTOP(INFO)
 9000 FORMAT(10E18.10E2)
C     NOTE: THE 9000 FORMAT STATEMENT IS REWRITTEN in 
C           evaluecalc.script, PRIOR TO COMPILING AND RUNNING.
 9001 FORMAT(3E16.8E2)
 9100 FORMAT(X)
 9101 FORMAT(X,/,
     &     'WARNING: because some of the equations do not',/,
     &     '         contain time derivatives, the error',/,
     &     '         bounds listed are only rough estimates',/,
     &     '         (see the user guide for details)',/,X)
      END
