C+    check_xyminmax_spectrum.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    WHEN PLOTTING THE EIGENVALUE SPECTRUM, THE USER IS
C+    GIVEN THE OPPPORTUNITY TO OVERIDE THE AXES LIMITS.
C+    IF NEW LIMITS ARE INPUT MANUALLY, THESE ARE 
C+    EXPECTED TO BE ENTERED IN ASCENDING ORDER (MIN THEN MAX)
C+    FOR X AND FOR Y. THIS PROGRAM CHECKS THE ORDER AND GIVES
C+    AN ERROR IF IT IS WRONG. NOTE THAT THIS MUST BE DONE IN A 
C+    FORTRAN PROGRAM RATHER THAN A SHELL SCRIPT BECAUSE IT INVOLVES
C+    REAL NUMBERS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(11,FILE='data_files/check_xyminmax_spectrum.input'
     &,STATUS='OLD')
      READ(11,*)X1,X2,Y1,Y2
      CLOSE(11)
      IF ((X1.LT.X2).AND.(Y1.LT.Y2)) THEN
         OPEN(12,FILE=
     &'../temp_files/spectrum_axes_limits.data'
     &,STATUS='NEW')
         WRITE(12,9000)X1
         WRITE(12,9000)X2
         WRITE(12,9000)Y1
         WRITE(12,9000)Y2
         CLOSE(12)
      ELSE
         PRINT*,'ERROR: BOTH PAIRS OF AXES LIMITS MUST'
         PRINT*,'       BE ENTERED IN ASCENDING ORDER'
         OPEN(20,FILE='../temp_files/fortran.error'
     &        ,STATUS='NEW')
         WRITE(20,'(''ERROR'')')
         CLOSE(20)
      ENDIF
      STOP
 9000 FORMAT(E16.8E2)
      END
