#+ spectrum_fixedcolour.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE PLOTS THE SPECTRUM FOR
#+ THE CASE OF A FIXED LINE COLOUR. IT IS CALLED BY
#+ THE COMMAND FILE spectrum.gp. 
#++
foldposition=vrmax.",".vimax
if (showspectrumfold eq "yes") \
set label vrmaxlabeltext at @foldposition right front textcolor rgb "black" \
 point pointsize foldsymbolsizesp pointtype 2 linecolor rgb "black" \
 offset character -1,0
if (empty1==0 || showperiodiceigenvalues ne "yes") evg0cmd1="" ; \
 else evg0cmd1=', "data_files/evg0.dat1" using 1:2 with points pointtype 7 \
 pointsize periodiceigenvaluessize linecolor rgb "black"'
if (empty2==0 || showperiodiceigenvalues ne "yes") evg0cmd2="" ; \
 else evg0cmd2=', "data_files/evg0.dat2" using 1:2 with points pointtype 4 \
 pointsize periodiceigenvaluessize linecolor rgb "black"'
# Now set up plotting of spectrum
system "selectdata_doublespace.script data_files/spectrum.plotdata data_files/spectrum.gpdata \
 '$$c1 $$c2 $$c4' '$$c3 -ne 0'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
set xtics nooffset
set ytics nooffset
set xlabel xlabeltext textcolor rgb "black"
set ylabel ylabeltext textcolor rgb "black"
set size 1.0-leftspace-rightspace,1.0-topspace-bottomspace
set origin leftspace,bottomspace
# Now define the main plotting command
zeroaxescmd='"data_files/spectrum.xaxisdata" using 1:2 with lines linetype 0 \
 linewidth 1.0 linecolor rgb "black", "data_files/spectrum.yaxisdata" using 1:2 \
 with lines linetype 0 linewidth 1.0 linecolor rgb "black"'
# Note: plot zeroaxes in this way so that there is something to plot when spectrumcolour="none"
if (spectrumcolour eq "none") \
 spectrumcmd='plot '.zeroaxescmd ; \
 else \
 spectrumcmd='plot "data_files/spectrum.gpdata" using 1:2 with lines \
 linetype -1 @linethickness linecolor @spectrumcolour, '.zeroaxescmd
# Finally issue the plot command
@spectrumcmd@evg0cmd1@evg0cmd2
# End of command file
