C+    periodtext.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CONVERTS THE PERIOD INTO TWO STRINGS,
C+    FOR USE WHEN PLOTTING THE PARAMETER PLANE.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(15,FILE='../temp_files/periodtext.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)DUMMY1,DUMMY2,PERIOD
      CLOSE(15)
      OPEN(11,FILE='../temp_files/periodtext.output1'
     &,STATUS='NEW')
      OPEN(12,FILE='../temp_files/periodtext.output2'
     &,STATUS='NEW')
      IF (PERIOD.LE.0.0D0) THEN
         WRITE(11,9200)
         WRITE(12,9200)
         CLOSE(11)
         CLOSE(12)
         STOP
      ENDIF
      IPRD2=INT(LOG10(PERIOD))
      IF (IPRD2.GE.1) THEN
         PRDPRT=PERIOD/(10.0D0**IPRD2)
         IF (PRDPRT.GT.9.5D0) THEN
            PRDPRT=1.0D0
            IPRD2=IPRD2+1
         ENDIF
         IF (IPRD2.GE.10) THEN
            WRITE(11,9000)
            WRITE(12,9002)
         ELSE
            WRITE(11,9100)PRDPRT
            WRITE(12,9001)IPRD2
         ENDIF
      ENDIF
      IF ((IPRD2.EQ.0).AND.(PERIOD.GE.1.0D0)) THEN
         WRITE(11,9100)PERIOD
         WRITE(12,9002)
      ENDIF
      IF ((IPRD2.LE.(-1))
     &     .OR.((IPRD2.EQ.0).AND.(PERIOD.LT.1.0D0))) THEN
         PRDPRT=PERIOD/(10.0D0**(IPRD2-1))
         IF (PRDPRT.GT.9.5D0) THEN
            PRDPRT=1.000001D0
C           The slight increment above 1 is to ensure that there
C           are no problems arising from the comparison test with
C           1.0D0.
            IPRD2=IPRD2+1
         ENDIF
         IF ((IPRD2.EQ.1).AND.(PRDPRT.GE.1.0D0)) THEN
            WRITE(11,9100)PERIOD
            WRITE(12,9002)
         ELSE
            IF (IPRD2.LE.(-9)) THEN
               WRITE(11,9004)
               WRITE(12,9002)
            ELSE
               WRITE(11,9100)PRDPRT
               WRITE(12,9003)(-IPRD2+1)
            ENDIF
         ENDIF
      ENDIF
      CLOSE(11)
      CLOSE(12)
      STOP
 9000 FORMAT('inf')
 9001 FORMAT('e+',I1)
 9002 FORMAT('e00')
 9003 FORMAT('e-',I1)
 9004 FORMAT('0.0')
 9100 FORMAT(F3.1)
 9200 FORMAT('---')
      END
