C+    set_bd_axes_limits.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM SETS THE AXES LIMITS FOR BIFURCATION DIAGRAM PLOTS
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL FIRST,ONLYSS
      DIMENSION BDDATA(7),BDMAX(7),BDMIN(7)
      OPEN(12,FILE='data_files/variable.data',STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)IVAR
      CLOSE(12)
      OPEN(11,FILE='data_files/bd.data',STATUS='OLD')
      REWIND(11)
      FIRST=.TRUE.
      DO 100 I=1,1000000
         READ(11,*,END=101)(BDDATA(J),J=1,7),IDATA
         IF (IVAR.EQ.0) THEN
            BDDATA(7)=BDDATA(2)
C           THIS MAKES BDDATA(7) THE NORM IN ALL CASES
C           THE INDICES REFER TO: 1=PP_OR_C   2=NOT USED
C           3=PERIOD   4=MAX   5=MEAN   6=MIN   7=NORM
         ENDIF
         IF (IDATA.EQ.1) THEN
            DO 110 J=1,7
               IF (FIRST) THEN
                  BDMIN(J)=BDDATA(J)
                  BDMAX(J)=BDDATA(J)
               ELSE
                  BDMIN(J)=MIN(BDMIN(J),BDDATA(J))
                  BDMAX(J)=MAX(BDMAX(J),BDDATA(J))
               ENDIF
 110        CONTINUE
            FIRST=.FALSE.
         ENDIF
 100  CONTINUE
      CLOSE(11)
      PRINT*,'ERROR IN set_bd_axes_limits.f'
      PRINT*,'      LOOP 100 FINISHED'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      STOP
 101  CONTINUE
      CLOSE(11)
      XMIN=BDMIN(1)
      XMAX=BDMAX(1)
      IF (XMIN.EQ.XMAX) THEN
         PRINT*,'ERROR: THERE IS NO VARIATION IN THE'
         PRINT*,'       VARIABLE TO BE PLOTTED ON THE'
         PRINT*,'       HORIZONTAL AXIS'
         OPEN(20,FILE='../temp_files/fortran.error'
     &        ,STATUS='NEW')
         WRITE(20,'(''ERROR'')')
         CLOSE(20)
         STOP
      ENDIF
C     Now generate max and min according to the options selected
      OPEN(13,FILE='data_files/bd.columns'
     &,STATUS='OLD')
      REWIND(13)
      FIRST=.TRUE.
      DO 200 I=1,10
         READ(13,*,END=201)ICOLUM
         IF (FIRST) THEN
            YMIN=BDMIN(ICOLUM)
            YMAX=BDMAX(ICOLUM)
            FIRST=.FALSE.
         ENDIF
         YMAX=MAX(YMAX,BDMAX(ICOLUM))
         YMIN=MIN(YMIN,BDMIN(ICOLUM))
 200  CONTINUE
      CLOSE(13)
      PRINT*,'ERROR IN set_bd_axes_limits.f'
      PRINT*,'      LOOP 200 FINISHED'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      STOP
 201  CONTINUE
C     Now read in steady state and alter max/min if appropriate
      OPEN(14,FILE='data_files/bd.qstst'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)IQSTST
      CLOSE(14)
      IF (IQSTST.EQ.1) THEN
         OPEN(15,FILE='data_files/bd.stst'
     &,STATUS='OLD')
         REWIND(15)
         ONLYSS=FIRST
         DO 300 I=1,100000
            READ(15,*,END=301)X,SSCOL2,SSCOL3,ISTST
            IF (IVAR.EQ.0) THEN
               STST=SSCOL2
            ELSE
               STST=SSCOL3
            ENDIF
            IF (ISTST.EQ.1) THEN
               IF (FIRST) THEN
                  YMIN=STST
                  YMAX=STST
                  FIRST=.FALSE.
               ELSE
                  IF ((((X.GE.XMIN).AND.(X.LE.XMAX)).
     &                 OR.(ONLYSS))) THEN
                     YMIN=MIN(YMIN,STST)
                     YMAX=MAX(YMAX,STST)
                  ENDIF
               ENDIF
            ENDIF
C           The point here is that there may be significant regions 
C           of the pp/c range in which there are no periodic travelling 
C           waves. For the most instructive plot, these should not be 
C           included in the plotting range for pp/c; however the steady 
C           state computations will be over the full range of pp/c values.
 300     CONTINUE
         CLOSE(15)
         PRINT*,'ERROR IN set_bd_axes_limits.f'
         PRINT*,'      LOOP 300 FINISHED'
         OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
         WRITE(20,'(''ERROR'')')
         CLOSE(20)
         STOP
 301     CONTINUE
         CLOSE(15)
      ENDIF
      IF (YMIN.EQ.YMAX) THEN
         PRINT*,'ERROR: THERE IS NO VARIATION IN THE'
         PRINT*,'       VARIABLE(S) TO BE PLOTTED ON'
         PRINT*,'       THE VERTICAL AXIS'
         OPEN(20,FILE='../temp_files/fortran.error'
     &        ,STATUS='NEW')
         WRITE(20,'(''ERROR'')')
         CLOSE(20)
         STOP
      ENDIF
C     Now increase the axes limits a bit above strict max and min,
C     which makes for better pictures
      XDIFF=XMAX-XMIN
      IF (YMAX.EQ.YMIN) THEN
         YDIFF=0.05D0*YMAX
      ELSE
         YDIFF=YMAX-YMIN
      ENDIF
      XMAX=XMAX+0.05*XDIFF
      XMIN=XMIN-0.05*XDIFF
      YMAX=YMAX+0.05*YDIFF
      YMIN=YMIN-0.05*YDIFF
C     Now choose an appropriate number of significant figures
C     for the output of YMIN and YMAX; these are written to
C     the screen in plotprepare_bd.script and this will ensure
C     an output form that is most helpful to the user
      NSGFGS=MAX(3,3-INT(LOG10(ABS(2.0D0*(YMAX-YMIN)
     &     /(YMAX+YMIN)))))
      OPEN(16,FILE='data_files/set_bd_axes_limits.output'
     &,STATUS='NEW')
      WRITE(16,'(E16.8E2)')XMIN
      WRITE(16,'(E16.8E2)')XMAX
      IF (NSGFGS.EQ.3) THEN
         WRITE(16,9003)YMIN
         WRITE(16,9003)YMAX
      ENDIF
      IF (NSGFGS.EQ.4) THEN
         WRITE(16,9004)YMIN
         WRITE(16,9004)YMAX
      ENDIF
      IF (NSGFGS.EQ.5) THEN
         WRITE(16,9005)YMIN
         WRITE(16,9005)YMAX
      ENDIF
      IF (NSGFGS.EQ.6) THEN
         WRITE(16,9006)YMIN
         WRITE(16,9006)YMAX
      ENDIF
      IF (NSGFGS.EQ.7) THEN
         WRITE(16,9007)YMIN
         WRITE(16,9007)YMAX
      ENDIF
      IF (NSGFGS.EQ.8) THEN
         WRITE(16,9008)YMIN
         WRITE(16,9008)YMAX
      ENDIF
      IF (NSGFGS.EQ.9) THEN
         WRITE(16,9009)YMIN
         WRITE(16,9009)YMAX
      ENDIF
      IF (NSGFGS.GE.10) THEN
         WRITE(16,9010)YMIN
         WRITE(16,9010)YMAX
      ENDIF
      CLOSE(16)
      STOP
 9003 FORMAT(E11.3E2)
 9004 FORMAT(E12.4E2)
 9005 FORMAT(E13.5E2)
 9006 FORMAT(E14.6E2)
 9007 FORMAT(E15.7E2)
 9008 FORMAT(E16.8E2)
 9009 FORMAT(E17.9E2)
 9010 FORMAT(E18.10E2)
      END
