C+    set_spectrum_axes_limits.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM SETS THE AXES LIMITS FOR SPECTRUM PLOTS
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL FIRST
      OPEN(11,FILE='data_files/spectrum.plotdata',STATUS='OLD')
      REWIND(11)
      FIRST=.TRUE.
      DO 100 I=1,1000000
         READ(11,*,END=101)EVR,EVI,IFLAG
         IF (IFLAG.NE.0) THEN
            IF (FIRST) THEN  
               EVRMIN=EVR
               EVRMAX=EVR
               EVIMIN=EVI
               EVIMAX=EVI
               FIRST=.FALSE.
            ELSE
               EVRMIN=MIN(EVR,EVRMIN)
               EVRMAX=MAX(EVR,EVRMAX)
               EVIMIN=MIN(EVI,EVIMIN)
               EVIMAX=MAX(EVI,EVIMAX)
            ENDIF
         ENDIF
 100  CONTINUE
      CLOSE(11)
      PRINT*,'ERROR IN set_spectrum_axes_limits.f'
      PRINT*,'      LOOP 100 FINISHED'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      STOP
 101  CONTINUE
      CLOSE(11)
C     Now add on data for periodic eigenvalues: include this even
C     if showperiodiceigenvalues is set to "no" since the user can
C     always "zoom in" by manually overiding the preset axes limits
      OPEN(12,FILE='data_files/evalues.data',STATUS='OLD')
      REWIND(12)
      DO 200 I=1,1000000
         READ(12,*,END=201)EVR,EVI
         EVRMIN=MIN(EVR,EVRMIN)
         EVRMAX=MAX(EVR,EVRMAX)
         EVIMIN=MIN(EVI,EVIMIN)
         EVIMAX=MAX(EVI,EVIMAX)
 200  CONTINUE
      CLOSE(12)
      PRINT*,'ERROR IN set_spectrum_axes_limits.f'
      PRINT*,'      LOOP 200 FINISHED'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      STOP
 201  CONTINUE
      CLOSE(12)
C     Now increase the axes limits a bit above strict max and min,
C     which makes for better pictures
      XDIFF=EVRMAX-EVRMIN
      YDIFF=EVIMAX-EVIMIN
      XMAX=EVRMAX+0.05*XDIFF
      XMIN=EVRMIN-0.05*XDIFF
      YMAX=EVIMAX+0.05*YDIFF
      YMIN=EVIMIN-0.05*YDIFF
C     Now choose an appropriate number of significant figures
C     for the output of XMIN, XMAX, YMIN and YMAX; these are 
C     written to the screen in plotprepare_spectrum.script and 
C     this will ensure an output form that is most helpful to 
C     the user
      NSGFGX=MAX(3,3-INT(LOG10(ABS(2.0D0*(XMAX-XMIN)
     &     /(XMAX+XMIN)))))
      NSGFGY=MAX(3,3-INT(LOG10(ABS(2.0D0*(YMAX-YMIN)
     &     /(YMAX+YMIN)))))
      OPEN(16,FILE='data_files/set_spectrum_axes_limits.output'
     &,STATUS='NEW')
      IF (NSGFGX.LE.3) THEN
         WRITE(16,9003)XMIN
         WRITE(16,9003)XMAX
      ENDIF
      IF (NSGFGX.EQ.4) THEN
         WRITE(16,9004)XMIN
         WRITE(16,9004)XMAX
      ENDIF
      IF (NSGFGX.EQ.5) THEN
         WRITE(16,9005)XMIN
         WRITE(16,9005)XMAX
      ENDIF
      IF (NSGFGX.EQ.6) THEN
         WRITE(16,9006)XMIN
         WRITE(16,9006)XMAX
      ENDIF
      IF (NSGFGX.EQ.7) THEN
         WRITE(16,9007)XMIN
         WRITE(16,9007)XMAX
      ENDIF
      IF (NSGFGX.EQ.8) THEN
         WRITE(16,9008)XMIN
         WRITE(16,9008)XMAX
      ENDIF
      IF (NSGFGX.EQ.9) THEN
         WRITE(16,9009)XMIN
         WRITE(16,9009)XMAX
      ENDIF
      IF (NSGFGX.GE.10) THEN
         WRITE(16,9010)XMIN
         WRITE(16,9010)XMAX
      ENDIF
      IF (NSGFGY.LE.3) THEN
         WRITE(16,9003)YMIN
         WRITE(16,9003)YMAX
      ENDIF
      IF (NSGFGY.EQ.4) THEN
         WRITE(16,9004)YMIN
         WRITE(16,9004)YMAX
      ENDIF
      IF (NSGFGY.EQ.5) THEN
         WRITE(16,9005)YMIN
         WRITE(16,9005)YMAX
      ENDIF
      IF (NSGFGY.EQ.6) THEN
         WRITE(16,9006)YMIN
         WRITE(16,9006)YMAX
      ENDIF
      IF (NSGFGY.EQ.7) THEN
         WRITE(16,9007)YMIN
         WRITE(16,9007)YMAX
      ENDIF
      IF (NSGFGY.EQ.8) THEN
         WRITE(16,9008)YMIN
         WRITE(16,9008)YMAX
      ENDIF
      IF (NSGFGY.EQ.9) THEN
         WRITE(16,9009)YMIN
         WRITE(16,9009)YMAX
      ENDIF
      IF (NSGFGY.GE.10) THEN
         WRITE(16,9010)YMIN
         WRITE(16,9010)YMAX
      ENDIF
      CLOSE(16)
      STOP
 9003 FORMAT(E11.3E2)
 9004 FORMAT(E12.4E2)
 9005 FORMAT(E13.5E2)
 9006 FORMAT(E14.6E2)
 9007 FORMAT(E15.7E2)
 9008 FORMAT(E16.8E2)
 9009 FORMAT(E17.9E2)
 9010 FORMAT(E18.10E2)
      END
