C+    detect_hb_test.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CHECKS WHETHER AUTO HAS DETECTED A HOPF BIFURCATION
C+    IN THE TRAVELLING WAVE EQUATIONS. IF NOT, IDTECT IS GIVEN A VALUE
C+    AS FOLLOWS:
C+        IDTECT=11 or 12: AUTO COMPLETED CONTINUATION ACROSS THE RANGE
C+                         OF VALUES OF THE CONTROL PARAMETER SPECIFIED
C+                         IN equations.input, BUT WITHOUT DETECTING A 
C+                         HOPF BIFURCATION. IF IWAVE>0, IDETCT=11; 
C+                         THIS INDICATES THAT SOMETHING IS WRONG WITH 
C+                         THE HOPF BIFURCATION SEARCH RANGE SET IN
C+                         equations.input.
C+                         IF IWAVE=0, IDETCT=12; THIS INDICATES THAT
C+                         THERE IS NO PERIODIC TRAVELLING WAVE FOR 
C+                         THE GIVEN VALUES OF THE CONTROL PARAMETER 
C+                         AND WAVE SPEED. (ASSUMING THAT THE SETTING 
C+                         IWAVE=0 HAS BEEN USED APPROPRIATELY).
C+               IDTECT=2: AUTO FINISHED CONTINUATION WITHOUT COVERING
C+                         THE WHOLE RANGE OF VALUES OF THE CONTROL 
C+                         PARAMETER SPECIFIED IN equations.input. 
C+                         THE MOST LIKELY REMEDIES FOR THIS WOULD BE  
C+                         EITHER TO ADD MORE CONTINUATION STEPS OR TO
C+                         MAKE THE ds VALUES LARGER.
C+               idtect=3: CONVERGENCE PROBLEM IN AUTO.
C+    IF A HOPF BIFURCATION HAS BEEN DETECTED, THE VALUE OF CONTROL 
C+    PARAMETER AT WHICH IT OCCURRED IS WRITTEN TO THE FILE 
C+    detect_hb_test.output
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*1 ADTECT
      CALL GINFO(INFO)
      ADTECT='n'
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*)
 600  CONTINUE
      DO 100 I=1,100000
         IFINAL=I
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB,PP,RNORM
         IF (ITY.EQ.3) THEN
            ADTECT='y'
            OPEN(15,FILE='../temp_files/detect_hb_test.output'
     &,STATUS='NEW')
            WRITE(15,9001)PP
            CLOSE(15)
            GOTO 102
         ENDIF
         IF (ITY.EQ.(-9)) THEN
            IDTECT=3
            GOTO 102
         ENDIF
 100  CONTINUE
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 100 IN detect_hb_test.f'')')
      CLOSE(66)
      CLOSE(12)
      ADTECT='n'
      WRITE(6,9000)ADTECT
      CALL ISTOP(INFO)
 101  CONTINUE
C     auto converged but didn't find a Hopf bifurcation
      OPEN(16,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(16)
      READ(16,*)PPATOL,PPRTOL
      CLOSE(16)
      IF (IFINAL.EQ.1) THEN
         OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: NO REAL OUTPUT LINES IN FILE 12'',
     &        '' in detect_hb_test.f'')')
         CLOSE(66)
         CLOSE(12)
         ADTECT='n'
         WRITE(6,9000)ADTECT
         CALL ISTOP(INFO)
      ENDIF
      OPEN(17,FILE='r.ptw.11'
     &,STATUS='OLD')
      REWIND(17)
      READ(17,*)
      READ(17,*)
      READ(17,*)
      READ(17,*)IDUMMY,RL0,RL1
      CLOSE(17)
      IF ((ABS(PPATOL).GT.ABS(0.01D0*RL0)).OR.
     & (ABS(PPATOL).GT.ABS(0.01*RL1))) THEN
         OPEN(69,FILE='../temp_files/detect.warning1'
     &,STATUS='NEW')
         WRITE(69,'(/,
     &''WARNING: THE VALUE OF controlatol IS RATHER LARGE'',/,
     &''         COMPARED TO ONE (OR BOTH) OF THE CONTROL'',/,
     &''         PARAMETER VALUES LIMITING THE SEARCH FOR'',/,
     &''         A HOPF BIFURCATION POINT.'',/,
     &''         THIS MAY BE APPROPRIATE, BUT IT MIGHT'',/,
     &''         ALSO INDICATE THAT controlatol SHOULD'',/,
     &''         BE REDUCED IN defaults.input''
     &,/)')
         CLOSE(69)
      ENDIF
      PPTST1=RL0*(1+PPRTOL)+PPATOL
      PPTST2=RL1*(1-PPRTOL)-PPATOL
C     Note: the purpose of PPTST1 and PPTST2 is to add a little wiggle
C        room to the min/max values of pp, to allow for auto classifying
C        that the end point has been reached when in fact pp falls just
C        short of the end point.
      IF ((PP.LE.PPTST1).OR.(PP.GE.PPTST2)) THEN
         OPEN(19,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
         READ(19,*)
         READ(19,*)IWAVE
         CLOSE(19)
         IF (IWAVE.EQ.0) THEN
            IDTECT=12
         ELSE
            IDTECT=11
         ENDIF
      ELSE
         IDTECT=2
      ENDIF
 102  CLOSE(12)
      CALL DWARN(IPT)
      WRITE(6,9000)ADTECT
C     screen output not "message": feeds into a pipe
      OPEN(14,FILE='../temp_files/outcome.data'
     &,STATUS='NEW')
      WRITE(14,9002)IDTECT
      CLOSE(14)
      CALL ISTOP(INFO)
 9000 FORMAT(A1)
 9001 FORMAT(E18.10E2)
 9002 FORMAT(I2)
      END

      SUBROUTINE DWARN(IPT)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL DOWARN
      CHARACTER*5 WORD1
      CHARACTER*28 WORD2
      CHARACTER*8 WORD3
      CHARACTER*25 ATYPE
C-----
      ATYPE='HOPF BIFURCATION POINT.  '
C      ATYPE='PERIODIC TRAVELLING WAVE.'
C      ATYPE='FOLD POINT.              '
C      ATYPE='ECKHAUS POINT.           '
C      ATYPE='HOPF POINT.              '
C      ATYPE='SOLN OF THE RIGHT PERIOD.'
C-----
      OPEN(23,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(23)
      DO 230 I230=1,11
         READ(23,*)
 230  CONTINUE
      READ(23,*)NWARN1,NWARN2
      CLOSE(23)
      IPT=ABS(IPT)
      DOWARN=.FALSE.
      IF (IPT.LT.NWARN1) THEN
         DOWARN=.TRUE.
         WORD1='SMALL'
         WORD2='JUMPING OVER BIFURCATION PTS'
         WORD3='INCREASE'
      ENDIF
      IF (IPT.GT.NWARN2) THEN
         DOWARN=.TRUE.
         WORD1='LARGE'
         WORD2='UNNECESSARILY LONG RUN TIMES'
         WORD3='DECREASE'
      ENDIF
      IF (DOWARN) THEN
         OPEN(66,FILE='../temp_files/detect.warning'
     &,STATUS='NEW')
         WRITE(66,9000)WORD1,IPT,ATYPE,WORD2,WORD3
         CLOSE(66)
      ENDIF
      RETURN
 9000 FORMAT(/,'WARNING: A RATHER ',A5,' NUMBER OF',
     &     ' CONTINUATION STEPS (=',I5,')',/,
     &     ' WAS TAKEN LOOKING FOR THE ',
     &     A25,/,'TO AVOID ',A28,' IT MIGHT BE',
     &     ' HELPFUL TO',/,A8,' THE RELEVANT',
     &     ' ds, dsmin AND dsmax',
     &     ' IN constants.input.',/)
      END
