C+    ptw_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR THE
C+    PERIODIC TRAVELLING WAVE CALCULATIONS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL AUTO,RUN00,RUN11,RUN22,RUN44,RUN55
      AUTO=.FALSE.
      CALL GINFO(INFO)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)IWAVE
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)DS1,DSMIN1,DSMAX1
      READ(12,*)DS2,DSMIN2,DSMAX2
      CLOSE(12)
C-----
      OPEN(14,FILE='../temp_files/ptw.input'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)PP
      READ(14,*)C
      READ(14,*)NTST
      CLOSE(14)
      CALL HBLIMS(PP,C,IHDRCT,PPHOPF,HBLIM1,HBLIM2,AUTO)
      IF (IWAVE.EQ.0) THEN
         IF (IHDRCT.EQ.0) THEN
            HBLIM2=PP
C           NOTE: THIS IS THE ONLY PLACE IN THE ANY OF THE 
C                 PROGRAMS WHERE iwave=0 AND iwave=1 ARE DIFFERENT.
         ELSE
            OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
            WRITE(66,'(''ERROR: IWAVE=0 CAN ONLY BE USED'')')
            WRITE(66,'(''WITH A DIRECT WAVE SEARCH'')')
            CLOSE(66)
            CALL IOUT(INFO,'error')
            CALL ISTOP(INFO)      
         ENDIF
      ENDIF
      IF (HBLIM1.GT.HBLIM2) THEN
         ISIGN=-1
      ELSE
         ISIGN=+1
      ENDIF
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(11,FILE='../temp_files/defaults.input' 
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PPATOL,PPRTOL
      READ(11,*)CATOL,CRTOL
      READ(11,*)
      READ(11,*)NMX1,NMX2,DUM1,DUM2,DUM3,NMXDUM
      READ(11,*)A0,A1
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
      OPEN(13,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      CLOSE(13)
C-----
C     End of reading in. 
      OPEN(17,FILE='../temp_files/ptwsearchmethod.txt'
     &,STATUS='NEW')
C     Now decide which r files are required.
      IF (IHDRCT.EQ.0) THEN
         WRITE(17,9000)
         RUN00=.FALSE.
         RUN11=.TRUE.
         RUN22=.TRUE.
         RUN44=.FALSE.
         RUN55=.FALSE.
         IRS22=2
         RL011=MIN(HBLIM1,HBLIM2)-0.01D0*ABS(HBLIM2-HBLIM1)
         RL111=MAX(HBLIM1,HBLIM2)+0.01D0*ABS(HBLIM2-HBLIM1)
C        NOTE: the increments of 1% of ABS(HBLIM2-HBLIM1) are to make sure
C           that the starting value of the bifurcation parameter (either
C           the control parameter or the wave speed), which is HBLIM1, 
C           definitely lies inside the computational interval. If it is 
C           exactly on the edge then rounding errors etc might push it 
C           outside.
         RL011=RL011-2.0D0*(PPATOL+PPRTOL*ABS(RL011))
         RL111=RL111+2.0D0*(PPATOL+PPRTOL*ABS(RL111))
         RL022=MIN(RL011,PPMIN-0.01D0*(PPMAX-PPMIN))
         RL122=MAX(RL111,PPMAX+0.01D0*(PPMAX-PPMIN))
C        NOTE: RL011 and RL111 are included to ensure that the Hopf
C           bifurcation point is in range, as well as the control 
C           parameter value for which a periodic travelling wave is 
C           sought. The inclusion of 1% of (PPMAX-PPMIN) is to make sure 
C           that the control parameter value for which a periodic 
C           travelling wave is sought is definitely an internal 
C           point, inside the specified range.
      ENDIF
      IF (IHDRCT.EQ.1) THEN
         RUN00=.FALSE.
         WRITE(17,9001)PPHOPF
         RUN11=.TRUE.
         RL011=MIN(HBLIM1,HBLIM2)-0.01D0*ABS(HBLIM2-HBLIM1)
         RL111=MAX(HBLIM1,HBLIM2)+0.01D0*ABS(HBLIM2-HBLIM1)
C        NOTE: the increments of 1% of ABS(HBLIM2-HBLIM1) are to make sure
C           that the starting value of the bifurcation parameter (either
C           the control parameter or the wave speed), which is HBLIM1, 
C           definitely lies inside the computational interval. If it is 
C           exactly on the edge then rounding errors etc might push it 
C           outside.
         RL011=RL011-2.0D0*(CATOL+CRTOL*ABS(RL011))
         RL111=RL111+2.0D0*(CATOL+CRTOL*ABS(RL111))
         RUN44=.TRUE.
         IRS44=2
         IF (ABS(PP-PPHOPF).GE.(PPATOL+PPRTOL*ABS(PPHOPF))) THEN
            RUN22=.TRUE.
            RUN55=.TRUE.
            IRS22=4
            RL022=MIN(PPHOPF,PPMIN)-0.01D0*(PPMAX-PPMIN)
            RL122=MAX(PPHOPF,PPMAX)+0.01D0*(PPMAX-PPMIN)
C           NOTE: PPHOPF is included to ensure that the 
C             starting point is in range, as well as the control 
C             parameter value for which a periodic travelling wave is 
C             sought. The inclusion of 1% of (PPMAX-PPMIN) is to make 
C             sure that the control parameter value for which a periodic 
C             travelling wave is sought is definitely an internal point,
C             inside the specified range.
         ELSE
            IF (IWAVE.GT.1) THEN
               OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
               WRITE(66,'(''ERROR: IWAVE>1 CANNOT BE USED'')')
               WRITE(66,'(''BECAUSE THE REQUIRED CONTROL'')')
               WRITE(66,'(''PARAMETER IS TOO CLOSE TO'')')
               WRITE(66,'(''THE VALUE USED FOR THE HOPF'')')
               WRITE(66,'(''BIFURCATION SEARCH, AND THUS'')')
               WRITE(66,'(''THE CONTINUATION DIRECTION'')')
               WRITE(66,'(''FOR THE CONTROL PARAMETER IS'')')
               WRITE(66,'(''NOT DETERMINED.'')')
               CLOSE(66)
               CALL IOUT(INFO,'error')
               CALL ISTOP(INFO)      
            ENDIF
            RUN22=.FALSE.
            RUN55=.FALSE.
         ENDIF
         IF (RUN55) THEN
            OPEN(15,FILE='../temp_files/is_direction_ok1.input',
     &           STATUS='NEW')
            WRITE(15,'(2E18.10E2)')PPHOPF,PP
            CLOSE(15)
         ENDIF
      ENDIF
      IF (IHDRCT.EQ.2) THEN
         RUN00=.TRUE.
         IRS00=1
         WRITE(17,9002)HBLIM1,HBLIM2
         RUN11=.FALSE.
         IF (ABS(C-HBLIM2).GE.(CATOL+CRTOL*ABS(HBLIM2))) THEN
            RUN44=.TRUE.
            IRS44=1
            IF (ABS(PP-HBLIM1).GE.(PPATOL+PPRTOL*ABS(HBLIM1))) THEN
               RUN22=.TRUE.
               IRS22=2
               RL022=MIN(HBLIM1,PPMIN)-0.01D0*(PPMAX-PPMIN)
               RL122=MAX(HBLIM1,PPMAX)+0.01D0*(PPMAX-PPMIN)
               RUN55=.TRUE.
            ELSE
               IF (IWAVE.GT.1) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &                 ,STATUS='NEW')
                  WRITE(66,'(''ERROR: IWAVE>1 CANNOT BE USED'')')
                  WRITE(66,'(''BECAUSE THE REQUIRED CONTROL'')')
                  WRITE(66,'(''PARAMETER IS TOO CLOSE TO'')')
                  WRITE(66,'(''THE VALUE USED FOR THE FILE'')')
                  WRITE(66,'(''ptwsoln.input, AND THUS'')')
                  WRITE(66,'(''THE CONTINUATION DIRECTION'')')
                  WRITE(66,'(''FOR THE CONTROL PARAMETER IS'')')
                  WRITE(66,'(''NOT DETERMINED.'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)      
               ENDIF
               RUN22=.FALSE.
               RUN55=.FALSE.
            ENDIF
         ELSE
            RUN44=.FALSE.
            IF (ABS(PP-HBLIM1).GE.(PPATOL+PPRTOL*ABS(HBLIM1))) THEN
               RUN22=.TRUE.
               IRS22=1
               RL022=MIN(HBLIM1,PPMIN)-0.01D0*(PPMAX-PPMIN)
               RL122=MAX(HBLIM1,PPMAX)+0.01D0*(PPMAX-PPMIN)
               RUN55=.TRUE.
            ELSE
               IF (IWAVE.GT.1) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &                 ,STATUS='NEW')
                  WRITE(66,'(''ERROR: IWAVE>1 CANNOT BE USED'')')
                  WRITE(66,'(''BECAUSE THE REQUIRED CONTROL'')')
                  WRITE(66,'(''PARAMETER IS TOO CLOSE TO'')')
                  WRITE(66,'(''THE VALUE USED FOR THE FILE'')')
                  WRITE(66,'(''ptwsoln.input, AND THUS'')')
                  WRITE(66,'(''THE CONTINUATION DIRECTION'')')
                  WRITE(66,'(''FOR THE CONTROL PARAMETER IS'')')
                  WRITE(66,'(''NOT DETERMINED.'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)      
               ENDIF
               RUN22=.FALSE.
               RUN55=.FALSE.
C              Note: in this case there is no computation to do:
C                    the required solution is just the one in 
C                    the file ptwsoln.input
            ENDIF
         ENDIF
         IF (RUN55) THEN
            OPEN(15,FILE='../temp_files/is_direction_ok1.input',
     &           STATUS='NEW')
            WRITE(15,'(2E18.10E2)')HBLIM1,PP
            CLOSE(15)
         ENDIF
      ENDIF
      CLOSE(17)
      IF (RUN22.OR.RUN55) THEN
         RL022=RL022-2.0D0*(PPATOL+PPRTOL*ABS(RL022))
         RL122=RL122+2.0D0*(PPATOL+PPRTOL*ABS(RL122))
      ENDIF
C-----
c     Now write the files
      IPS=1
      IRS=0
      ILP=0
      NICP=1
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=0
      NINT=0
      NPR1=NMX1
      NPR2=NMX2
      MXBF=10
      IID=2
      ITMX=8
      ITNW=5
      NWTN=3
      JAC=0
      IADS=1
C-----
      IF (RUN11) THEN
      IF (IHDRCT.EQ.0) THEN
         ICP=1
      ELSE
         ICP=2
      ENDIF
      OPEN(13,FILE='r.ptw.11'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(13,'(2I8)')NICP,ICP
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX1,RL011,RL111,A0,A1
      WRITE(13,'(I8,6I3)')NPR1,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS1)),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(13)
      ENDIF
C-----
      IF (RUN44) THEN
      IPS=2
      NICP=2
      ICP1=2
      ICP2=11
      IF (IHDRCT.EQ.1) THEN
         CMIN=MIN(C,HBLIM1,HBLIM2)
         CMAX=MAX(C,HBLIM1,HBLIM2)
      ELSE
         CMIN=MIN(C,HBLIM2)
         CMAX=MAX(C,HBLIM2)
      ENDIF
      RL044=CMIN-0.1D0*(CMAX-CMIN)
      RL144=CMAX+0.1D0*(CMAX-CMIN)
C     NOTE: the increments of 10% of (CMAX-CMIN) are to make sure
C           that the start and target values of the bifurcation parameter
C           (the wave speed) definitely lie inside the computational 
C           interval. If they are exactly on the edge then
C           rounding errors etc might push them outside.
      RL044=RL044-2.0D0*(CATOL+CRTOL*ABS(RL044))
      RL144=RL144+2.0D0*(CATOL+CRTOL*ABS(RL144))
      OPEN(13,FILE='r.ptw.44'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS44,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX1,RL044,RL144,A0,A1
      WRITE(13,'(I8,6I3)')NPR1,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS1)),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(13,'(''-2'',E16.8E2)')C
      CLOSE(13)
      OPEN(13,FILE='r.ptw.44otherdirection'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS44,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX1,RL044,RL144,A0,A1
      WRITE(13,'(I8,6I3)')NPR1,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(-ISIGN*ABS(DS1)),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(13,'(''-2'',E16.8E2)')C
      CLOSE(13)
      ENDIF
C-----
      IF (RUN22) THEN
      IPS=2
      NICP=2
      ICP1=1
      ICP2=11
C-----
      OPEN(13,FILE='r.ptw.22'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS22,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX2,RL022,RL122,A0,A1
      WRITE(13,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(13,'(''-1'',E16.8E2)')PP
      CLOSE(13)
      ENDIF
C-----
      IF (RUN55) THEN
      OPEN(13,FILE='r.ptw.22otherdirection'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS22,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX2,RL022,RL122,A0,A1
      WRITE(13,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(-ISIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(13,'(''-1'',E16.8E2)')PP
      CLOSE(13)
      NMX2=NMXDUM
C     This is an arbitrary small number of continuation steps.
      NPR2=NMX2
C     Note: the same IRS value is used for runs 22 and 55. 
C           The purpose of run 55 is to test whether or 
C           not auto has gone in the required direction. 
C           Such a test is not needed for run 22 in the 
C           direct case because it starts at the Hopf 
C           bifurcation, which is the starting point of 
C           the branch of periodic travelling waves, and
C           so continuation can only proceed in one direction.
C           Note that the direction selected for run 22 is
C           inherited by run 33.
      OPEN(13,FILE='r.ptw.55'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS22,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX2,RL022,RL122,A0,A1
      WRITE(13,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(13,'(''-1'',E16.8E2)')PP
      CLOSE(13)
      ENDIF
C-----
      IF (RUN00) THEN
      IPS=2
      NICP=2
      ICP1=2
      ICP2=11
      CMIN=MIN(C,HBLIM2)
      CMAX=MAX(C,HBLIM2)
C     NOTE: IHDRCT must be 2 in this case.
      RL000=CMIN-0.1D0*(CMAX-CMIN)
      RL100=CMAX+0.1D0*(CMAX-CMIN)
C     NOTE: the increments of 10% of (CMAX-CMIN) are to make sure
C           that the start and target values of the bifurcation parameter
C           (the wave speed) definitely lie inside the computational 
C           interval. If they are exactly on the edge then
C           rounding errors etc might push them outside.
      RL000=RL000-2.0D0*(CATOL+CRTOL*ABS(RL000))
      RL100=RL100+2.0D0*(CATOL+CRTOL*ABS(RL100))
      OPEN(13,FILE='r.ptw'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS00,ILP
      WRITE(13,'(3I8)')NICP,ICP1,ICP2
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMXDUM,RL000,RL100,A0,A1
      WRITE(13,'(I8,6I3)')NMXDUM,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS1)),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(13)
C     NOTE: the file r.ptw is used in the file conversion,
C           and to test the continuation direction
      OPEN(15,FILE='../temp_files/is_direction_ok2.input',
     &STATUS='NEW')
      WRITE(15,'(2E18.10E2)')HBLIM2,C
      CLOSE(15)
      ENDIF
C-----
      STOP
 9000 FORMAT(X,/,'Search method is: direct')
 9001 FORMAT(X,/,'Search method is: indirect',/,
     &     'The Hopf bifn search is at control',
     &     ' parameter=',E18.10E2)
 9002 FORMAT(X,/,'Search method is: file',/,
     &     'The starting solution has parameters:',/,
     &     '   control parameter=',E18.10E2,/,
     &     '          wave speed=',E18.10E2)
      END
