C+    prepare_to_plot_spectrum.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM IS RUN AFTER ALL OF THE AUTO CALCULATIONS 
C+    ASSOCIATED WITH THE EIGENVALUE SPECTRUM, AND CREATES DATA
C+    FILES IN A FORM SUITABLE FOR PLOTTING.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*3 AI
      LOGICAL LFOLDS,FIRST,LRH
      CALL GINFO(INFO)
C-----
      JMAX1=1000000
C     max counter in loops 200 and 250
      JMAX2=1000000
C     max counter in loop 300
C-----
      OPEN(11,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(11)
      DO 700 I=1,7
         READ(11,*)
 700  CONTINUE
      READ(11,*)DS,DSMIN,DSMAX
      CLOSE(11)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      DO 701 I=1,7
         READ(11,*)
 701  CONTINUE
      READ(11,*)EVZERO
      READ(11,*)GEXTRA
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)GHRNGE
      CLOSE(11)
C-----
      PI=ACOS(-1.0D0)
      ZERO=0.0D0
      IONE=1
      IZERO=0
      OPEN(11,FILE='data_files/spectrum.nfiles'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NFILES
      CLOSE(11)
      OPEN(13,FILE='data_files/spectrum.plotdata'
     &,STATUS='NEW')
      OPEN(17,FILE='../temp_files/prepare_to_plot_spectrum.folds'
     &,STATUS='NEW')
      LRH=.FALSE.
      DO 100 I=101,NFILES
         OPEN(21,FILE='../temp_files/prepare_to_plot_spectrum.temp'
     &,STATUS='OLD')
         REWIND(21)
         WRITE(21,'(I3)')I
         CLOSE(21)
         OPEN(21,FILE='../temp_files/prepare_to_plot_spectrum.temp'
     &,STATUS='OLD')
      REWIND(21)
         READ(21,'(A3)')AI
         CLOSE(21)
         OPEN(15,FILE='data_files/spectrum.evalue'//AI
     &,STATUS='OLD')
      REWIND(15)
         READ(15,*)G0EVR,G0EVI
         CLOSE(15)
         WRITE(13,9000)G0EVR,G0EVI,IZERO,ZERO
         OPEN(12,FILE='data_files/spectrum.spectrumdata'//AI
     &,STATUS='OLD')
      REWIND(12)
         FIRST=.TRUE.
         DO 200 J=1,JMAX1
            READ(12,*,END=201)EVR,EVI,GAMMA,ITY
C            IF (GAMMA.GT.-DSMIN) THEN 
C            This unneccesary restriction was removed 10/05/2010: gamma
C            is either positive or very slightly negative due to errors
C            in locating the user-specified output at gamma=0.
               WRITE(13,9000)EVR,EVI,IONE,GAMMA
               IF (ITY.EQ.4) THEN
                  IF ((FIRST).AND.(GEXTRA.GE.(10.0D0*DSMIN))) THEN
                     FIRST=.FALSE.
                  ELSE
                     GOTO 201
                  ENDIF
               ENDIF
C            ENDIF
 200     CONTINUE
C        NOTE: THE REASON TESTING FOR THE USER SPECIFIED OUTPUT POINT AT
C              gamma=2*pi+gextra, RATHER THAN JUST WRITING TO FILE 13 IF
C              gamma<2*pi+gextra, IS THAT OFTEN THERE WILL BE NO OUTPUTS
C              IN BETWEEN 2*pi and 2*pi+gextra, AND THAT THE USER 
C              SPECIFIED OUTPUT AT 2*pi+gextra MAY ACTUALLY BE AT A gamma
C              VALUE SLIGHTLY ABOVE 2*pi+gextra.
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: LOOP 200 FINISHED IN'',
     &        '' prepare_to_plot_spectrum.f'',/,
     &        7X,''AT i='',I5)')I
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
 201     CLOSE(12)
         WRITE(13,9000)ZERO,ZERO,IZERO,ZERO
         OPEN(12,FILE='data_files/spectrum.spectrumdata'//AI
     &,STATUS='OLD')
      REWIND(12)
C        NOW CHECK WHETHER THE SPECTRUM AWAY FROM THE ORIGIN IS
C        IN THE RIGHT HAND HALF OF THE COMPLEX PLANE
         DO 350 J=1,JMAX1
            READ(12,*,END=351)EVR,EVI
            IF ((EVR.GE.ZERO).AND.
     &           (SQRT(EVR*EVR+EVI*EVI).GT.EVZERO)) THEN
               LRH=.TRUE.
            ENDIF
 350     CONTINUE
C        NOW LOOK FOR FOLDS, EXCLUDING THE ORIGIN.
C        THIS HAS TWO UNRELATED PURPOSES. FIRSTLY, THE SPECTRUM
C          MIGHT PROTRUDE INTO THE RIGHT HAND HALF PLANE, 
C          IN BETWEEN DATA POINTS. SECONDLY, THE FOLD WITH THE
C          LARGEST REAL PART IS USED AS A STARTING POINT FOR 
C          LOCATING AND THEN TRACING A STABILITY BOUNDARY OF
C          HOPF TYPE.
 351     REWIND(12)
         READ(12,*,END=251)EVR1,EVI1,GAMMA1
         READ(12,*,END=251)EVR2,EVI2,GAMMA2
         DO 250 J=3,JMAX1
         READ(12,*,END=251)EVR3,EVI3,GAMMA3
            IF ((EVR2.GT.EVR1).AND.(EVR2.GT.EVR3)) then
               CALL TP(EVI1,EVR1,EVI2,EVR2,
     &              EVI3,EVR3,EVITP,EVRTP)
               IF (SQRT(EVRTP**2+EVITP**2).GT.EVZERO) THEN
                  CALL TP(GAMMA1,EVR1,GAMMA2,EVR2,
     &                 GAMMA3,EVR3,GMTP,DUMMY)
                  EVRMAX=EVRTP
                  EVIMAX=ABS(EVITP)
                  GMX=GMTP
                  IMAX=I
                  WRITE(17,9002)EVRMAX,EVIMAX,GMX,IMAX
               ENDIF
            ENDIF
            EVR1=EVR2
            EVI1=EVI2
            GAMMA1=GAMMA2
            EVR2=EVR3
            EVI2=EVI3
            GAMMA2=GAMMA3
 250     CONTINUE
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: LOOP 250 FINISHED IN'',
     &        '' prepare_to_plot_spectrum.f'',/,
     &        7X,''AT i='',I5)')I
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
 251     CLOSE(12)
 100  CONTINUE
      CLOSE(13)
      CLOSE(17)
C-----
      LFOLDS=.FALSE.
      OPEN(17,FILE='../temp_files/prepare_to_plot_spectrum.folds'
     &,STATUS='OLD')
      REWIND(17)
      DO 300 IFOLD=1,JMAX2
         READ(17,*,END=301)EVRMAX,EVIMAX,GMX,IMAX
         LFOLDS=.TRUE.
         IF ((IFOLD.EQ.1).OR.
     &        (EVRMAX.GT.ERMXMX)) THEN
            ERMXMX=EVRMAX
            EIMXMX=EVIMAX
            GMXMAX=GMX
            IMXMX=IMAX
         ENDIF
 300  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 300 FINISHED IN'',
     &     '' prepare_to_plot_spectrum.f'',/,
     &     7X,''AT i='',I5)')I
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 301  CLOSE(17)
C     read in the eigenvalue from which the continuation giving
C     the fold with maximum real part was started
      IF (LFOLDS) THEN
         OPEN(21,FILE='../temp_files/spectrum.codemax'
     &,STATUS='NEW')
         WRITE(21,'(I3)')IMXMX
         CLOSE(21)
         OPEN(21,FILE='../temp_files/spectrum.codemax'
     &,STATUS='OLD')
      REWIND(21)
         READ(21,'(A3)')AI
         CLOSE(21)
         OPEN(15,FILE='data_files/spectrum.evalue'//AI
     &,STATUS='OLD')
      REWIND(15)
         READ(15,*)STRMAX,STIMAX
         CLOSE(15)
         OPEN(24,FILE='../temp_files/spectrum.grangemax'
     &,STATUS='NEW')
         WRITE(24,'(2F16.8)')(GMXMAX-0.5D0*GHRNGE),
     &(GMXMAX+0.5D0*GHRNGE)
         CLOSE(24)
      ELSE
C        no folds found away from the origin, so just output the origin
         ERMXMX=0.0D0
         EIMXMX=0.0D0
         GMXMAX=0.0D0
         STRMAX=0.0D0
         STIMAX=0.0D0
         IMXMX=0
      ENDIF
C-----
      OPEN(16,FILE='data_files/spectrum.max'
     &,STATUS='NEW')
      WRITE(16,9001)ERMXMX,EIMXMX,GMXMAX,
     &     STRMAX,STIMAX,IMXMX
      CLOSE(16)
      OPEN(17,FILE='../temp_files/outcome.data'
     &,STATUS='NEW')
      IF ((.NOT.LRH).AND.
     &     ((ERMXMX.LT.0.0D0).OR.(.NOT.LFOLDS))) THEN
         WRITE(17,'('' 6'')')
C     STABLE
      ELSE
         WRITE(17,'('' 7'')')
C     UNSTABLE
      ENDIF
      CLOSE(17)
C-----
      CALL ISTOP(INFO)
 9000 FORMAT(2E16.8E2,I3,E16.8E2)
 9001 FORMAT(E18.10E2,4E16.8E2,I5)
 9002 FORMAT(3E16.8E2,I8)
      END
      SUBROUTINE TP(X1,Y1,X2,Y2,X3,Y3,XTP,YTP)
      IMPLICIT REAL*8 (A-H,K,O-Z)
C     THIS SUBROUTINE FINDS THE PARABOLA y=a*x^2+b*x+c THROUGH 
C     THREE GIVEN POINTS AND RETURNS THE COORDINATES OF 
C     THE TURNING POINT
      A=(Y1*(X2-X3)+Y2*(X3-X1)+Y3*(X1-X2))/
     &  ((X1-X2)*(X2-X3)*(X1-X3))
      B=(Y1-Y2)/(X1-X2)-A*(X1+X2)
      C=Y1-A*X1*X1-B*X1
      XTP=-B/(2*A)
      YTP=C-B*B/(4*A)
      RETURN
      END
